## qtbase-opensource-src 5.2.1+dfsg

=== tests/auto/cmake/CMakeLists.txt ===

# This is an automatic test for the CMake configuration files.
# To run it manually,
# 1) mkdir build   # Create a build directory
# 2) cd build
# 3) cmake ..      # Run cmake on this directory.
# 4) ctest         # Run ctest
#
# The expected output is something like:
#
#       Start  1: test_use_modules_function
#  1/11 Test  #1: test_use_modules_function ........   Passed    3.36 sec
#       Start  2: test_wrap_cpp_and_resources
#  2/11 Test  #2: test_wrap_cpp_and_resources ......   Passed    1.41 sec
#       Start  3: test_dependent_modules
#  3/11 Test  #3: test_dependent_modules ...........   Passed    2.22 sec
#       Start  4: test_add_resource_options
#  4/11 Test  #4: test_add_resource_options ........   Passed    0.16 sec
#       Start  5: test_wrap_cpp_options
#  5/11 Test  #5: test_wrap_cpp_options ............   Passed    0.36 sec
#       Start  6: test_needsquoting_dirname
#  6/11 Test  #6: test_needsquoting_dirname ........   Passed    2.20 sec
#       Start  7: test_platform_defs_include
#  7/11 Test  #7: test_platform_defs_include .......   Passed    0.28 sec
#       Start  8: test_qtmainwin_library
#  8/11 Test  #8: test_qtmainwin_library ...........   Passed    1.27 sec
#       Start  9: test_dbus_module
#  9/11 Test  #9: test_dbus_module .................   Passed    3.46 sec
#       Start 10: test_multiple_find_package
# 10/11 Test #10: test_multiple_find_package .......   Passed    0.07 sec
#       Start 11: test_add_resources_delayed_file
# 11/11 Test #11: test_add_resources_delayed_file ..   Passed    0.38 sec
#
#
# Note that if Qt is not installed, or if it is installed to a
# non-standard prefix, the environment variable CMAKE_PREFIX_PATH
# needs to be set to the installation prefix or build prefix of Qt
# before running these tests.

cmake_minimum_required(VERSION 2.8)

project(qmake_cmake_files)

enable_testing()

find_package(Qt5Core REQUIRED)

include("${_Qt5CTestMacros}")

if(NOT ${CMAKE_VERSION} VERSION_LESS 2.8.9)
    # Requires INCLUDE_DIRECTORIES target property in CMake 2.8.8
    # and POSITION_INDEPENDENT_CODE target property in 2.8.9
    expect_pass(test_use_modules_function)
    expect_pass(test_umbrella_config)
else()
    message("CMake version older than 2.8.9 (Found ${CMAKE_VERSION}). Not running test \"test_use_modules_function\" or \"test_umbrella_config\"")
endif()

expect_pass(test_wrap_cpp_and_resources)
if (NOT NO_WIDGETS)
    expect_pass(test_dependent_modules)
    expect_pass("test(needsquoting)dirname")
endif()
expect_fail(test_add_resource_options)
expect_fail(test_wrap_cpp_options)
expect_pass(test_platform_defs_include)
expect_pass(test_qtmainwin_library)

if (NOT NO_DBUS)
    expect_pass(test_dbus_module)
endif()
expect_pass(test_multiple_find_package)
if (NOT WIN32 OR (WIN32 AND NOT CMAKE_VERSION VERSION_LESS 2.8.11))
    # Broken on windows on earlier CMake versions.
    # http://public.kitware.com/Bug/view.php?id=13392
    expect_pass(test_add_resources_delayed_file)
endif()
expect_pass(test_private_includes)
expect_pass(test_testlib_definitions)
expect_pass(test_json_plugin_includes)

expect_fail(test_testlib_no_link_gui)
execute_process(COMMAND ${CMAKE_COMMAND} -E copy
    "${CMAKE_CURRENT_SOURCE_DIR}/test_testlib_definitions/main.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/failbuild/test_testlib_no_link_gui/test_testlib_no_link_gui/"
)

if (NOT NO_WIDGETS)
    expect_fail(test_testlib_no_link_widgets)
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy
        "${CMAKE_CURRENT_SOURCE_DIR}/test_testlib_definitions/main.cpp"
        "${CMAKE_CURRENT_BINARY_DIR}/failbuild/test_testlib_no_link_widgets/test_testlib_no_link_widgets/"
    )
endif()

set(qt_module_includes
  Core QObject
  Gui QImage
  Network QHostInfo
  Sql QSqlError
  Test QTestEventList
  Xml QDomDocument
)

if (NOT NO_WIDGETS)
  list(APPEND qt_module_includes
    Widgets QWidget
    OpenGL QGLBuffer
    PrintSupport QPrinter
  )
endif()

if (NOT NO_DBUS)
  list(APPEND qt_module_includes
    DBus QDBusMessage
  )
endif()

test_module_includes(
  ${qt_module_includes}
)
expect_pass(test_concurrent_module)
expect_pass(test_openglextensions_module)
if (QT_WITH_ANGLE OR (NOT WIN32 AND NOT APPLE AND NOT NO_EGL))
    expect_pass(test_egl_lib)
endif()
expect_pass(test_opengl_lib)

if (NOT CMAKE_VERSION VERSION_LESS 2.8.11)
    expect_pass(test_interface)
endif()

if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
    expect_pass(test_interface_link_libraries)
    expect_pass(test_moc_macro_target)
endif()

=== src/3rdparty/iaccessible2/idl/Makefile ===

MIDL        = midl
MIDL_OPTS   = /out ..\generated

first: all

all: x86 amd64

MIDL_OPTS   = /out ..\generated\x86 /env win32

x86:
	-del ..\generated\x86\dlldata.c
	-md ..\generated\x86
	$(MIDL) $(MIDL_OPTS) Accessible2.idl
	$(MIDL) $(MIDL_OPTS) AccessibleAction.idl
	$(MIDL) $(MIDL_OPTS) AccessibleApplication.idl
	$(MIDL) $(MIDL_OPTS) AccessibleComponent.idl
	$(MIDL) $(MIDL_OPTS) AccessibleEditableText.idl
	$(MIDL) $(MIDL_OPTS) AccessibleEventID.idl
	$(MIDL) $(MIDL_OPTS) AccessibleHyperlink.idl
	$(MIDL) $(MIDL_OPTS) AccessibleHypertext.idl
	$(MIDL) $(MIDL_OPTS) AccessibleImage.idl
	$(MIDL) $(MIDL_OPTS) AccessibleRelation.idl
	$(MIDL) $(MIDL_OPTS) AccessibleRole.idl
	$(MIDL) $(MIDL_OPTS) AccessibleStates.idl
	$(MIDL) $(MIDL_OPTS) AccessibleTable.idl
	$(MIDL) $(MIDL_OPTS) AccessibleTable2.idl
	$(MIDL) $(MIDL_OPTS) AccessibleTableCell.idl
	$(MIDL) $(MIDL_OPTS) AccessibleText.idl
	$(MIDL) $(MIDL_OPTS) AccessibleValue.idl
	$(MIDL) $(MIDL_OPTS) IA2CommonTypes.idl
	$(MIDL) $(MIDL_OPTS) IA2TypeLibrary.idl

MIDL_OPTS   = /out ..\generated\amd64 /env amd64

amd64:
	-del ..\generated\amd64\dlldata.c
	-md ..\generated\amd64
	$(MIDL) $(MIDL_OPTS) Accessible2.idl
	$(MIDL) $(MIDL_OPTS) AccessibleAction.idl
	$(MIDL) $(MIDL_OPTS) AccessibleApplication.idl
	$(MIDL) $(MIDL_OPTS) AccessibleComponent.idl
	$(MIDL) $(MIDL_OPTS) AccessibleEditableText.idl
	$(MIDL) $(MIDL_OPTS) AccessibleEventID.idl
	$(MIDL) $(MIDL_OPTS) AccessibleHyperlink.idl
	$(MIDL) $(MIDL_OPTS) AccessibleHypertext.idl
	$(MIDL) $(MIDL_OPTS) AccessibleImage.idl
	$(MIDL) $(MIDL_OPTS) AccessibleRelation.idl
	$(MIDL) $(MIDL_OPTS) AccessibleRole.idl
	$(MIDL) $(MIDL_OPTS) AccessibleStates.idl
	$(MIDL) $(MIDL_OPTS) AccessibleTable.idl
	$(MIDL) $(MIDL_OPTS) AccessibleTable2.idl
	$(MIDL) $(MIDL_OPTS) AccessibleTableCell.idl
	$(MIDL) $(MIDL_OPTS) AccessibleText.idl
	$(MIDL) $(MIDL_OPTS) AccessibleValue.idl
	$(MIDL) $(MIDL_OPTS) IA2CommonTypes.idl
	$(MIDL) $(MIDL_OPTS) IA2TypeLibrary.idl

=== tests/auto/cmake/test_add_resource_options/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_add_resource_options)

if (EXISTS "${CMAKE_CURRENT_LIST_DIR}/FindPackageHints.cmake")
    include("${CMAKE_CURRENT_LIST_DIR}/FindPackageHints.cmake")
endif()

find_package(Qt5Core REQUIRED HINTS ${Qt5Tests_PREFIX_PATH})

include_directories(${Qt5Core_INCLUDE_DIRS})

add_definitions(${Qt5Core_DEFINITIONS})

qt5_wrap_cpp(moc_files myobject.h)

# Test options. The -binary option generates a binary to dlopen instead of
# a source file to compile. The compiler will consider it garbage when used
# in the add_executable call.
qt5_add_resources(rcc_files "test_macro_options.qrc" OPTIONS -binary)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

add_executable(myobject myobject.cpp ${moc_files} ${rcc_files})
target_link_libraries(myobject ${Qt5Core_LIBRARIES})

=== tests/auto/cmake/test_opengl_lib/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_opengl_lib)

find_package(Qt5Gui REQUIRED)

include_directories(${Qt5Gui_INCLUDE_DIRS} ${Qt5Gui_OPENGL_INCLUDE_DIRS} )
add_definitions(${Qt5Gui_DEFINITIONS})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}")

if (${Qt5Gui_OPENGL_IMPLEMENTATION} STREQUAL GLES)
    add_definitions(-DGL_IMPLEMENTATION_GLES1)
elseif (${Qt5Gui_OPENGL_IMPLEMENTATION} STREQUAL GLESv2)
    add_definitions(-DGL_IMPLEMENTATION_GLES2)
elseif (${Qt5Gui_OPENGL_IMPLEMENTATION} STREQUAL GL)
    add_definitions(-DGL_IMPLEMENTATION_GL)
else()
    message(SEND_ERROR "Qt5Gui_OPENGL_IMPLEMENTATION does not contain valid data.")
endif()

add_executable(myobject main.cpp )
target_link_libraries(myobject ${Qt5Gui_LIBRARIES} ${Qt5Gui_OPENGL_LIBRARIES})

=== tests/auto/cmake/test_testlib_definitions/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8.3)

project(test_testlib_definitions)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

macro(test_testlib_project _module)
    find_package(Qt5${_module} REQUIRED)
    find_package(Qt5Test REQUIRED)

    add_definitions(
        ${Qt5${_module}_DEFINITIONS}
        ${Qt5Test_DEFINITIONS}
    )

    include_directories(
        ${Qt5${_module}_INCLUDE_DIRS}
        ${Qt5Test_INCLUDE_DIRS}
    )

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5${_module}_EXECUTABLE_COMPILE_FLAGS}")

    set(main_file "${CMAKE_CURRENT_SOURCE_DIR}/../main.cpp")
    set(moc_file "${CMAKE_CURRENT_BINARY_DIR}/main.moc")

    qt5_generate_moc("${main_file}" "${moc_file}")

    add_executable(testapp_${_module} "${main_file}" "${moc_file}")
    target_link_libraries(testapp_${_module}
        ${Qt5${_module}_LIBRARIES}
        ${Qt5Test_LIBRARIES}
    )
endmacro()

add_subdirectory(core_only)
add_subdirectory(gui)
if(NOT NO_WIDGETS)
    add_subdirectory(widgets)
endif()

=== tests/auto/cmake/test_use_modules_function/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_use_modules_function)

set(CMAKE_AUTOMOC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(two two.cpp)
add_executable(three three.cpp)

find_package(Qt5Core)

qt5_use_modules(two Test)
qt5_use_modules(three Gui Test)

=== debian/changelog ===
qtbase-opensource-src (5.2.1+dfsg-1ubuntu14.3) trusty; urgency=medium

  * Patching for Boundary iMX6 boards

 -- Laci Tele <laci@boundarydevices.com>  Sun, 23 Aug 2015 13:11:23 -0700

qtbase-opensource-src (5.2.1+dfsg-1ubuntu14.3) trusty-security; urgency=medium

  * SECURITY UPDATE: denial of service via crafted GIF image
    - debian/patches/CVE-2014-0190.patch: check for broken image in
      src/gui/image/qgifhandler.cpp.
    - CVE-2014-0190
  * SECURITY UPDATE: denial of service via crafted BMP
    - debian/patches/CVE-2015-0295.patch: fix division by zero in
      src/gui/image/qbmphandler.cpp.
    - CVE-2015-0295
  * SECURITY UPDATE: denial of service and possible code execution via
    crafted BMP or ICO images
    - debian/patches/CVE-2015-1858-1859.patch: move check to better
      location in src/gui/image/qbmphandler.cpp, check depth in
      src/plugins/imageformats/ico/qicohandler.cpp.
    - CVE-2015-1858
    - CVE-2015-1859
  * SECURITY UPDATE: denial of service and possible code exection via
    crafted GIF image
    - debian/patches/CVE-2015-1860.patch: check bounds in
      src/gui/image/qgifhandler.cpp.
    - CVE-2015-1860

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 27 May 2015 13:55:50 -0400

qtbase-opensource-src (5.2.1+dfsg-1ubuntu14.2) trusty; urgency=medium

  * debian/patches/xi2-use-master-device.patch:
    - Make xi2 select events on master device instead of slaves.
      (LP: #1307701)

 -- Maarten Lankhorst <maarten.lankhorst@ubuntu.com>  Tue, 06 May 2014 13:14:17 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu14.1) trusty; urgency=medium

  [ Dmitry Shachnev ]
  * Backport upstream patch to fix issues with keymap update handling
    (Add_better_support_for_keymap_update_handling.patch, copied from
    Debian and rebased). (LP: #1318482)
  * Build-depend on libxkbcommon-x11-dev, as the new patch includes
    <xkbcommon/xkbcommon-x11.h>.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 28 Apr 2014 03:11:01 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu14) trusty; urgency=medium

  * libqt5gui5.symbols, libqt5opengl5.symbols: making the gl/gles symbols
    optional, and creating a list of generic and gl/gles specifics symbols,
    so we can provide a set of packages built with the OpenGL ES backend on
    i386 and amd64
  * debian/rules: don't override makeshlibs and leave it to be automatically
    created (so we can have proper >= version deps)

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Wed, 09 Apr 2014 18:59:26 -0300

qtbase-opensource-src (5.2.1+dfsg-1ubuntu13) trusty; urgency=medium

  * Update remaining symbols files with buildd's logs.

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Tue, 08 Apr 2014 11:46:46 -0300

qtbase-opensource-src (5.2.1+dfsg-1ubuntu12) trusty; urgency=medium

  * Update symbols files with buildd's logs.

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Mon, 07 Apr 2014 20:29:31 -0300

qtbase-opensource-src (5.2.1+dfsg-1ubuntu11) trusty; urgency=medium

  * debian/patches/When-looking-up-the-window-hierarchy-stop-at-foreign.patch
    - Cherry-pick a fix to a bug affecting online accounts (LP: #1299712)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Tue, 01 Apr 2014 12:41:00 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu10) trusty; urgency=medium

  * Make qt5-qmake Multi-Arch: same since it moved from shipping files in
    /usr/share to /usr/lib/<triplet>.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 18 Mar 2014 12:41:00 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu9) trusty; urgency=medium

  * debian/patches/Fix-access-after-delete-with-Harfbuzz-NG-code-path.patch
  * debian/patches/Fix-log_clusters-calculation-in-HarfBuzz-NG-code-pat.patch
  * debian/patches/HarfBuzz-NG-Hide-characters-that-should-normally-be-.patch
  * debian/patches/Minor-optimization-for-QTextEngine-shapeText.patch
    - Cherry-pick latest HarfBuzz-NG changes from upstream including the one 
      fixing the glyph issue https://codereview.qt-project.org/#change,81150
      (LP: #1285184)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Tue, 18 Mar 2014 06:00:49 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu8) trusty; urgency=medium

  * debian/patches/Add-workaround-for-GL-on-Android-emulator.patch:
    - Adding back the remaining piece that's not yet upstream, but needed
      for the Ubuntu Touch emulator

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Mon, 17 Mar 2014 19:49:43 -0300

qtbase-opensource-src (5.2.1+dfsg-1ubuntu7) trusty; urgency=medium

  [ Colin Watson ]
  * Add arm64 to archs that don't use -m64

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 10 Mar 2014 11:01:46 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu6) trusty; urgency=medium

  * Add Use-None-instead-of-GLX_NONE.patch:
    - Cherry-pick upstream patch (LP: #1288278)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 10 Mar 2014 05:34:12 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu5) trusty; urgency=medium

  * Only run tests on armhf, amd64 and i386.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Thu, 06 Mar 2014 05:24:13 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu4) trusty; urgency=medium

  [ Chris Gagnon ]
  * Enable unit tests

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 03 Mar 2014 18:50:34 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu3) trusty; urgency=medium

  * Revert the transitional package change final landing.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 03 Mar 2014 13:22:42 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu2) trusty; urgency=medium

  * libqt5core5 transitional package to be able to run ABI related tests

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 28 Feb 2014 13:56:19 +0000

qtbase-opensource-src (5.2.1+dfsg-1ubuntu1) trusty; urgency=low

  [ Dmitry Shachnev ]
  * Update watch file (taken from Debian).
  * Fix generating documentation by building qdoc before using it.


=== debian/control ===
Source: qtbase-opensource-src
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>,
           Modestas Vainius <modax@debian.org>,
           Sune Vuorela <debian@pusling.com>,
           Pino Toscano <pino@debian.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Timo Jyrinki <timo@debian.org>,
           Dmitry Shachnev <mitya57@gmail.com>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1),
               freetds-dev,
               gdb [!ppc64el],
               libasound2-dev [linux-any],
               libatspi2.0-dev,
               libcups2-dev,
               libdbus-1-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libgbm-dev [linux-any],
               libgl1-mesa-dev | libgl-dev,
               libgles2-mesa-dev [linux-any] | libgles2-dev [linux-any],
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgstreamer-plugins-base0.10-dev,
               libgstreamer0.10-dev,
               libgtk2.0-dev,
               libharfbuzz-dev,
               libicu-dev,
               libjpeg-dev,
               libmysqlclient-dev,
               libopenvg1-mesa-dev [amd64 armel armhf i386 powerpc kfreebsd-any],
               libpng-dev,
               libpq-dev,
               libpulse-dev,
               libsqlite3-dev,
               libssl-dev,
               libudev-dev [linux-any],
               libx11-dev,
               libx11-xcb-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-render-util0-dev,
               libxcb-render0-dev,
               libxcb-shape0-dev,
               libxcb-shm0-dev,
               libxcb-sync-dev,
               libxcb-xfixes0-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               libxrender-dev,
               pkg-kde-tools (>= 0.14.2),
               unixodbc-dev,
               xvfb,
               zlib1g-dev
Standards-Version: 3.9.5
Homepage: http://qt-project.org/
Vcs-Git: git://anonscm.debian.org/pkg-kde/qt/qtbase.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/qt/qtbase.git;a=summary
Vcs-Bzr: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/qtbase-opensource-src

Package: libqt5core5a
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Provides: qtbase-abi-5-2-1
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libthai0
Breaks: libqt5core5 (<< 5.2.0+dfsg~)
Replaces: libqt5core5 (<< 5.2.0+dfsg~)
Description: Qt 5 core module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtCore module contains core non-GUI functionality.

Package: libqt5gui5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: fontconfig, ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 GUI module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtGui module extends QtCore with GUI functionality.

Package: libqt5network5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 network module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtNetwork module offers classes that allow you to write TCP/IP clients and
 servers. It provides classes to make network programming easier and portable.

Package: libqt5opengl5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 OpenGL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtOpenGL module offers classes that make it easy to use OpenGL in Qt
 applications.
 .
 OpenGL is a standard API for rendering 3D graphics. OpenGL only deals with 3D
 rendering and provides little or no support for GUI programming issues.

Package: libqt5sql5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libqt5sql5-sqlite | libqt5sql5-mysql | libqt5sql5-odbc | libqt5sql5-psql
Description: Qt 5 SQL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtSql module helps you provide seamless database integration to your Qt
 applications.

Package: libqt5sql5-mysql
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 MySQL database driver
 This package contains the MySQL plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MySQL DB.

Package: libqt5sql5-odbc
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 ODBC database driver
 This package contains the ODBC plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access an
 ODBC DB.

Package: libqt5sql5-psql
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 PostgreSQL database driver
 This package contains the PostgreSQL plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 PostgreSQL DB.

Package: libqt5sql5-sqlite
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 SQLite 3 database driver
 This package contains the SQLite 3 plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access an
 SQLite 3 DB.

Package: libqt5sql5-tds
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 FreeTDS database driver
 This package contains the FreeTDS plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MS SQL or Sybase SQL server.

Package: libqt5xml5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 XML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtXml module provides a stream reader and writer for XML documents,
 and C++ implementations of SAX and DOM.

Package: libqt5dbus5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 D-Bus module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtDBus module is a Unix-only library that you can use to make Inter-Process
 Communication using the D-Bus protocol.
 .
 Applications using the QtDBus module can provide services to other, remote
 applications by exporting objects, as well as use services exported by those
 applications by placing calls and accessing properties.

Package: libqt5test5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 test module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtTest module provides classes for unit testing Qt applications and
 libraries.

Package: libqt5concurrent5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 concurrent module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtConcurrent module contains functionality to support concurrent execution
 of program code.

Package: libqt5widgets5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 widgets module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtWidgets module extends QtGui with C++ widget functionality.

Package: libqt5printsupport5
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libcups2
Description: Qt 5 print support module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtPrintSupport module provides classes to make printing easier and
 portable.

Package: qtbase5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: dpkg (>= 1.15.6~)
Depends: libgl1-mesa-dev [!armel !armhf] | libgl-dev [!armel !armhf],
         libgles2-mesa-dev | libgles2-dev,
         libglu1-mesa-dev [!armel !armhf] | libglu-dev [!armel !armhf],
         libqt5concurrent5 (= ${binary:Version}),
         libqt5core5a (= ${binary:Version}),
         libqt5dbus5 (= ${binary:Version}),
         libqt5gui5 (= ${binary:Version}),
         libqt5network5 (= ${binary:Version}),
         libqt5printsupport5 (= ${binary:Version}),
         libqt5sql5 (= ${binary:Version}),
         libqt5test5 (= ${binary:Version}),
         libqt5widgets5 (= ${binary:Version}),
         libqt5xml5 (= ${binary:Version}),
         qt5-qmake (= ${binary:Version}),
         qtbase5-dev-tools (= ${binary:Version}),
         qtchooser,
         ${misc:Depends}
Recommends: libqt5opengl5-dev (= ${binary:Version})
Suggests: libmysqlclient-dev,
          libpq-dev,
          libsqlite3-dev,
          unixodbc-dev
Description: Qt 5 base development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the header development files used for building Qt 5
 applications.

Package: qtbase5-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: dpkg (>= 1.15.6~)
Depends: qtbase5-dev (= ${binary:Version}), ${misc:Depends}
Breaks: qtbase5-dev (<< 5.0.2+dfsg1-3~)
Replaces: qtbase5-dev (<< 5.0.2+dfsg1-3~)
Description: Qt 5 base private development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the private header development files for building some
 Qt 5 applications like Qt Creator QML Designer plugin.
 .
 Use at your own risk.

Package: libqt5opengl5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: dpkg (>= 1.15.6~)
Depends: libqt5opengl5 (= ${binary:Version}),
         qtbase5-dev (= ${binary:Version}),
         ${misc:Depends}
Description: Qt 5 OpenGL library development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)

export PATH := $(PATH):$(shell pwd)/bin
export CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# Library package list for override_dh_makeshlibs, excludes -dev -dbg
pkgs_lib := $(filter-out %-dev %-dbg,$(filter lib%,$(shell dh_listpackages)))
# Upstream changelog
upstream_changes := $(wildcard dist/changes-*)
# Current debian version (e.g.: 4:4.5.2-1)
current_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
# Specific shlibs version (e.g.: 4:4.5.2)
shlibs_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-')
# Distribution vendor
vendor := $(shell dpkg-vendor --query Vendor)

# To easier the files installation according OSes and archs, we create three
# kinds of install files: foo.install-common, foo.install-$DEB_HOST_ARCH and
# foo.install-$DEB_HOST_ARCH_OS. In this case we can fine-tune what we install.
#
# Note that if any foo.install-* file exists and foo.install exist too, the
# later will get overwritten.
#
# I've opened a bug in debhelper to allow this:
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=703201

# Retrieve packages that have a .install-common file
pkgs_with_common = $(patsubst debian/%.install-common,%,$(wildcard debian/*.install-common))
# Retrieve packages that have a .install-$DEB_HOST_ARCH file
pkgs_with_arch = $(patsubst debian/%.install-$(DEB_HOST_ARCH),%,$(wildcard debian/*.install-$(DEB_HOST_ARCH)))
# Retrieve packages that have a .install-$DEB_HOST_ARCH_OS file
pkgs_with_os = $(patsubst debian/%.install-$(DEB_HOST_ARCH_OS),%,$(wildcard debian/*.install-$(DEB_HOST_ARCH_OS)))


ifneq (,$(filter %-sql-ibase,$(shell dh_listpackages)))
	extra_configure_opts += -plugin-sql-ibase
else
	extra_configure_opts += -no-sql-ibase
endif

no_pch_architectures := armel armhf ia64
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(no_pch_architectures)))
	extra_configure_opts += -no-pch
endif

armv6_architectures := armhf
ifeq ($(vendor),Ubuntu)
	armv6_architectures += armel
endif

gles2_architectures := armel armhf
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
	extra_configure_opts += -opengl es2
else
	extra_configure_opts += -opengl desktop
endif

# Only run tests on the archs they are known to pass with current configuration
ifneq (nocheck,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	testrun_architectures := armhf i386 amd64
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(filter $(DEB_HOST_ARCH),alpha arm64 ia64 mips64 mips64el))
	platform_arg = linux-g++
  else ifeq ($(DEB_HOST_ARCH_BITS),64)
	platform_arg = linux-g++-64
  else
	platform_arg = linux-g++
  endif
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
	platform_arg = hurd-g++
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
	platform_arg = gnukfreebsd-g++
else
	$(error Unknown qmake mkspec for $(DEB_HOST_ARCH_OS))
endif

extra_include_dirs += -I/usr/include/vivante
extra_include_dirs += -I/usr/include/mysql
extra_include_dirs += -I/usr/include/freetype2
extra_include_dirs += -I/usr/include/dbus-1.0
extra_include_dirs += -I/usr/include/glib-2.0
extra_include_dirs += -I/usr/include/gtk-2.0
extra_include_dirs += -I/usr/include/cairo
extra_include_dirs += -I/usr/include/pango-1.0
extra_include_dirs += -I/usr/include/gdk-pixbuf-2.0
extra_include_dirs += -I/usr/include/atk-1.0
extra_include_dirs += -I/usr/include/libdrm
extra_include_dirs += -I/usr/lib/arm-linux-gnueabihf/glib-2.0/include

%:
	dh $@ --parallel --with pkgkde_symbolshelper

override_dh_auto_configure:
	./configure -confirm-license \
	            -prefix "/usr" \
	            -bindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/bin" \
	            -libdir "/usr/lib/$(DEB_HOST_MULTIARCH)" \
	            -docdir "/usr/share/qt5/doc" \
	            -headerdir "/usr/include/qt5" \
	            -datadir "/usr/share/qt5" \
	            -archdatadir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5" \
	            -hostdatadir "/usr/share/qt5" \
	            -plugindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/plugins" \
	            -importdir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/imports" \
	            -translationdir "/usr/share/qt5/translations" \
	            -hostdatadir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5" \
	            -sysconfdir "/etc/xdg" \
	            -examplesdir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/examples" \
	            -opensource \
	            -verbose \
	            -optimized-qmake \
	            -plugin-sql-mysql \
	            -plugin-sql-odbc \
	            -plugin-sql-psql \
	            -plugin-sql-sqlite \
	            -no-sql-sqlite2 \
	            -plugin-sql-tds \
	            -system-sqlite \
	            -system-zlib \
	            -system-libpng \
	            -system-libjpeg \
	            -platform $(platform_arg) \
	            -xcb \
	            -no-kms \
	            -no-directfb \
	            -system-xcb \
	            -qt-pcre \
	            -qpa xcb \
	            -system-harfbuzz \
	            -openssl \
	            -no-rpath \
	            -dbus-linked \
	            -reduce-relocations \
	            -no-strip \
	            -no-separate-debug-info \
	            -glib \
	            -icu \
	            -accessibility \
	            -compile-examples \
	            -make tools \
	            -make examples \
	            -make libs \
	            -no-opengl \
	            $(extra_configure_opts) \
	            $(extra_include_dirs)
	sed -i "s%needed%needed -Wl,-rpath-link,/usr/lib/$(DEB_HOST_MULTIARCH)/vivante/x11 -Wl,-rpath-link,/usr/lib/$(DEB_HOST_MULTIARCH) -Wl,-rpath-link,/lib/$(DEB_HOST_MULTIARCH)%"  ./mkspecs/qmodule.pri
	

override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(testrun_architectures)))
		xvfb-run -a make check QT_PLUGIN_PATH=$(CURDIR)/plugins LD_LIBRARY_PATH=$(CURDIR)/lib PATH=$(CURDIR)/bin:$(PATH)
endif

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) confclean distclean

	# Extra stuff missed by confclean/distclean

	# Misc. files
	rm -f \
	  config.status \
	  config.tests/.qmake.cache \
	  examples/dbus/*/Makefile.* \
	  mkspecs/qconfig.pri \
	  src/corelib/global/qconfig.* \
	;

	# Misc. directories
	rm -rf \
	  doc-build/ \
	  doc/html/ \
	  doc/qch/ \
	  examples/tools/plugandpaint/plugins/ \
	  examples/tools/styleplugin/styles/ \
	  lib/ \
	  plugins/ \
	;

	# Leftover dirs
	find -depth -type d \( -false \
	  -o -name debug-shared \
	  -o -name debug-static \
	  -o -name \*.gch \
	  -o -name .moc\* \
	  -o -name .obj\* \
	  -o -name .pch \
	  -o -name pkgconfig \
	  -o -name .rcc \
	  -o -name release-shared \
	  -o -name release-static \
	  -o -name .uic \) -print \
        | xargs rm -rf

	# Leftover files and all symlinks
	find \( -false \
	  -o -name \*.a \
	  -o -name Makefile.Debug \
	  -o -name Makefile.Release \
	  -o -name \*.o \
	  -o -name \*.prl \
	  -o -name \*.so \
	  -o -name \*.so.debug \
	  -o -type l \) -print \
        | grep -v tests/auto/corelib/plugin/qpluginloader/elftest \
        | grep -v tests/auto/corelib/io/qdir/types \
        | grep -v tests/auto/corelib/plugin/qlibrary/library_path/invalid.so \
        | xargs rm -rf

	# Delete all Makefiles, excluding some from src/3rdparty
	find $(CURDIR) -name Makefile \
	  ! -path $(CURDIR)/src/3rdparty/Makefile \
	  ! -path $(CURDIR)/src/3rdparty/freetype/\* \
	  ! -path $(CURDIR)/src/3rdparty/zlib/\* \
	  ! -path $(CURDIR)/src/3rdparty/ptmalloc/Makefile \
	-print0 | xargs -0 rm -rf

	# Any remaining executables

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
http://download.qt-project.org/official_releases/qt/([\d\.]*)/([\d\.]*)/submodules/qtbase-opensource-src-([^-]*)\.tar.xz
